/* a program that will read in the JSON and CSV file and annotate the method routine
   trace objects with hasGuardState ("g"/"u") and isRunning ("r", "W" wait/block):
   WIP: work in progress

*/

fn=.sysCargs[1]      -- fetch the file name
if \SysFileExists(fn) then
do
   say "file ["fn"] does not exist, aborting ..."
   exit -1
end

args=.nil
if .sysCargs~items>1 then
   args=.sysCargs~section(2)  -- assign remainders as arguments


tab="09"x

say
arr =.array~new
.TraceObject~collector=arr
option="F"
.TraceObject~option=option
say "-"~copies(79)
msg = runner(fn, args, option, arr)
say "-"~copies(79)

say
say "trace:"
say
do traceobj over arr
   say traceObj
end
say "-"~copies(79)
say
say
say "  annotating state of traced method routines ..."
resArr=annotateRuntimeState(arr)
say
say "showing annotations ordered by AttributePoolNr and Nr:"
say
do 2
   do traceObj over resArr
      tmpStr=traceObj~makeString
      parse var tmpStr before ']' after
      say  adjLeft(traceObj~nr,3)                  before -
                 traceObj~hasGuardState~?('g','u')        -
                 traceObj~isRunning~?('.','W')"]"  after
   end
   say "-"~copies(50)
   say
   resArr~sort    -- now sort it by Nr, i.e. in trace sequence order
   say "showing annotations ordered by trace sequence:"
   say
end
say "-"~copies(79)
say
say

say info~center(79,'-')

say "... just testing datetime reconversion..."
traceObj=arr[1]
dt=traceObj~timestamp
say "dt~class:" dt~class "dt:" dt


::requires "traceutil.cls"    -- get TraceObject related utilities


::routine runner     -- in case the called program has an error, intercept it here
   use arg fn, args, option, arr
   signal on syntax
   say
   say
   say "---> "~copies(10)
   if args~isNil then strArgs=("n/a")
                 else strArgs=args~toString("L",",")
   say "about to call ["fn"] with args='"strArgs"', option='"option"', arr~items="arr~items "..."
   r=.routine~newFile(fn)
   if args~isNil then res=r~start("call")    -- run without arguments
                 else res=r~startWith("callWith", args) -- supply arguments for program
   do counter c while \res~hasResult
      call sysSleep 0.1    -- sleep a bit
      if c=20 then leave   -- leave after two seconds
   end

   .TraceObject~collector=.nil
   say center("   option '"option"': arr~items:" arr~items "",69,"-")

   if res~hasResult then say "-> normal program completion! :)"
                    else say "-> program seems to hang! :("
   return res     -- return message object

syntax:
   if VAR("SIGL") then  -- a condition occurred?
   do
      co=condition('o')
      say "SIGNAL   from calling ["fn"] with option="option "arr~items="arr~items "..."
      say "        name:" co~name":" co~instruction "sigl:" sigl
      say "   errortext:" co~errortext
      say "     message:" co~message
      say
   end
   else
      say "returned from calling ["fn"] with option='"option"' arr~items="arr~items "..."
   say "<--- "~copies(10)
   say
   say ".TraceObject~option:" .TraceObject~option ".TraceObject~collector:" .TraceObject~collector~objectname
   say
   say "waiting a little bit to have all threads exited (they generate additional traceObjects) ..."
   call syssleep .1
   .TraceObject~collector=.nil
   say center(" option '"option"': arr~items:" arr~items "",69,"-")
   return

